//+------------------------------------------------------------------+
//|                                            Check_FreezeLevel.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property description "  SYMBOL_TRADE_FREEZE_LEVEL  "
//---
#property strict
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
bool CheckOrderForFREEZE_LEVEL(int ticket)
  {
//---   SYMBOL_TRADE_FREEZE_LEVEL
   int freeze_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_FREEZE_LEVEL);
   if(freeze_level!=0)
     {
      PrintFormat("SYMBOL_TRADE_FREEZE_LEVEL=%d:   "+
                  "   %d    ",freeze_level,freeze_level);
     }
//---    
   if(!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
     {
      //---    
      return (false);
     }
//---   
   double price=OrderOpenPrice();
   double sl=OrderStopLoss();
   double tp=OrderTakeProfit();
   int type=OrderType();
//---   
   bool check=false;
//---   
   switch(type)
     {
      //---   BuyLimit
      case  OP_BUYLIMIT:
        {
         //---        
         check=((Ask-price)>freeze_level*_Point);
         if(!check)
            PrintFormat(" OP_BUYLIMIT #%d  : Ask-Open=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((Ask-price)/_Point),freeze_level);
         return(check);
        }
      //---   BuyLimit
      case  OP_SELLLIMIT:
        {
         //---        
         check=((price-Bid)>freeze_level*_Point);
         if(!check)
            PrintFormat(" OP_SELLLIMIT #%d  : Open-Bid=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((price-Bid)/_Point),freeze_level);
         return(check);
        }
      break;
      //---   BuyStop
      case  OP_BUYSTOP:
        {
         //---        
         check=((price-Ask)>freeze_level*_Point);
         if(!check)
            PrintFormat(" OP_BUYSTOP #%d  : Ask-Open=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((price-Ask)/_Point),freeze_level);
         return(check);
        }
      //---   SellStop
      case  OP_SELLSTOP:
        {
         //---        
         check=((Bid-price)>freeze_level*_Point);
         if(!check)
            PrintFormat(" OP_SELLSTOP #%d  : Bid-Open=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((Bid-price)/_Point),freeze_level);
         return(check);
        }
      break;
      //---     Buy
      case  OP_BUY:
        {
         //---    TakeProfit   
         bool TP_check=(tp-Bid>freeze_level*_Point);
         if(!TP_check)
            PrintFormat(" OP_BUY %d  : TakeProfit-Bid=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((tp-Bid)/_Point),freeze_level);
         //---    TakeProfit   
         bool SL_check=(Bid-sl>freeze_level*_Point);
         if(!SL_check)
            PrintFormat(" OP_BUY %d  : TakeProfit-Bid=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((Bid-sl)/_Point),freeze_level);
         return(SL_check&&TP_check);
        }
      break;
      //---     Sell
      case  OP_SELL:
        {
         //---    TakeProfit   
         bool TP_check=(Ask-tp>freeze_level*_Point);
         if(!TP_check)
            PrintFormat(" OP_SELL %d  : Ask-TakeProfit=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((Ask-tp)/_Point),freeze_level);
         //---    TakeProfit   
         bool SL_check=(sl-Ask>freeze_level*_Point);
         if(!SL_check)
            PrintFormat(" OP_BUY %d  : TakeProfit-Bid=%d  < SYMBOL_TRADE_FREEZE_LEVEL=%d ",
                        ticket,(int)((sl-Ask)/_Point),freeze_level);
         return(SL_check&&TP_check);
        }
      break;
     }
//---    
   return (false);
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---  
   int ticket;
//---     SL/TP
/*
   ...   
*/
//---         SYMBOL_TRADE_FREEZE_LEVEL
   if(CheckOrderForFREEZE_LEVEL(ticket))
     {
      //   ,  
     }

  }
//+------------------------------------------------------------------+
